Attribute VB_Name = "httpupload"
Private Declare Function InternetOpen Lib "wininet.dll" _
    Alias "InternetOpenA" _
    (ByVal lpszCallerName As String, _
    ByVal dwAccessType As Long, _
    ByVal lpszProxyName As String, _
    ByVal lpszProxyBypass As String, _
    ByVal dwFlags As Long) As Long

Private Declare Function InternetConnect Lib "wininet.dll" _
    Alias "InternetConnectA" _
    (ByVal hInternetSession As Long, _
    ByVal lpszServerName As String, _
    ByVal nProxyPort As Integer, _
    ByVal lpszUsername As String, _
    ByVal lpszPassword As String, _
    ByVal dwService As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) As Long

Private Declare Function InternetReadFile Lib "wininet.dll" _
    (ByVal hFile As Long, _
    ByVal sBuffer As String, _
    ByVal lNumBytesToRead As Long, _
    lNumberOfBytesRead As Long) As Integer

Private Declare Function HttpOpenRequest Lib "wininet.dll" _
    Alias "HttpOpenRequestA" _
    (ByVal hInternetSession As Long, _
    ByVal lpszVerb As String, _
    ByVal lpszObjectName As String, _
    ByVal lpszVersion As String, _
    ByVal lpszReferer As String, _
    ByVal lpszAcceptTypes As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) As Long

Private Declare Function HttpSendRequest Lib "wininet.dll" _
    Alias "HttpSendRequestA" _
    (ByVal hHttpRequest As Long, _
    ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, _
    ByVal sOptional As String, _
    ByVal lOptionalLength As Long) As Boolean

Private Declare Function InternetCloseHandle Lib "wininet.dll" _
    (ByVal hInternetHandle As Long) As Boolean

Private Declare Function HttpAddRequestHeaders Lib "wininet.dll" _
    Alias "HttpAddRequestHeadersA" _
    (ByVal hHttpRequest As Long, _
    ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, _
    ByVal lModifiers As Long) As Integer

Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Private Const INTERNET_SERVICE_HTTP = 3
Private Const INTERNET_DEFAULT_HTTP_PORT = 80
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const HTTP_ADDREQ_FLAG_ADD = &H20000000
Private Const HTTP_ADDREQ_FLAG_REPLACE = &H80000000



Public Function httpPostFile(server$, url$, file$, ByRef ptrResult$) As Boolean
    
    Dim hInternetOpen&, hInternetConnect&, hHttpOpenRequest&, lNumberOfBytesRead&
    Dim bRet As Boolean, bDoLoop As Boolean
    Dim sReadBuffer As String * 2048, sPostData$
    Dim nFile%
    
    On Error GoTo errorLabel
    
    hInternetOpen = 0
    hInternetConnect = 0
    hHttpOpenRequest = 0
    
    hInternetOpen = InternetOpen(App.EXEName, INTERNET_OPEN_TYPE_PRECONFIG, _
        vbNullString, vbNullString, 0)
    
    If hInternetOpen = 0 Then GoTo errorLabel
    
    hInternetConnect = InternetConnect(hInternetOpen, server, INTERNET_DEFAULT_HTTP_PORT, _
        vbNullString, "HTTP/1.0", INTERNET_SERVICE_HTTP, 0, 0)
    
    If hInternetConnect = 0 Then GoTo errorLabel
    
    hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", url, "HTTP/1.0", _
        vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
    
    If hHttpOpenRequest = 0 Then GoTo errorLabel
    
    sHeader = "Content-Type: multipart/form-data, boundary=AaB03x" & vbCrLf
    bRet = HttpAddRequestHeaders(hHttpOpenRequest, sHeader, Len(sHeader), _
        HTTP_ADDREQ_FLAG_REPLACE Or HTTP_ADDREQ_FLAG_ADD)
    
    'Datei zum posten in einen string lesen
    nFile = FreeFile
    Open file For Binary As #nFile
        sPostData = String(LOF(nFile), " ")
        Get #nFile, , sPostData
    Close #nFile
    
    'Die datei posten
    sPostData = _
    "--AaB03x" & vbCrLf & _
    "Content-Disposition: form-data; name=""fileupload""; filename=""" & file & """" & vbCrLf & _
    "Content-Transfer-Encoding: binary" & vbCrLf & _
    "Content-Type: application/octet-stream" & vbCrLf & vbCrLf & _
    sPostData & vbCrLf
    
    'Noch zwei andere variablen posten
    sPostData = sPostData & _
    "--AaB03x" & vbCrLf & _
    "Content-Disposition: form-data; name=""variable1""" & vbCrLf & vbCrLf & _
    "meine variable numero uno" & vbCrLf & _
    "--AaB03x" & vbCrLf & _
    "Content-Disposition: form-data; name=""variable2""" & vbCrLf & vbCrLf & _
    "meine variable zwei" & vbCrLf & _
    "--AaB03x--"
    
    bRet = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, sPostData, Len(sPostData))
    
    ptrResult = ""
    
    Do
        sReadBuffer = vbNullString
        bDoLoop = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        ptrResult = ptrResult & Left(sReadBuffer, lNumberOfBytesRead)
        If Not CBool(lNumberOfBytesRead) Or Not bDoLoop Then Exit Do
    Loop
    
    httpPostFile = True
    GoTo closeHandles
    
errorLabel:
    httpPostFile = False
    
closeHandles:
    
    If hInternetOpen <> 0 Then InternetCloseHandle hInternetOpen
    If hInternetConnect <> 0 Then InternetCloseHandle hInternetConnect
    If hHttpOpenRequest <> 0 Then InternetCloseHandle hHttpOpenRequest
End Function




